--- uboot/vendors/ami/ncsi/ncsistart.c	2010-04-06 16:54:06.000000000 +0800
+++ uboot_new/vendors/ami/ncsi/ncsistart.c	2010-04-06 16:55:23.000000000 +0800
@@ -68,6 +68,8 @@
 	UINT8 Major;
 	int DefaultPort = 0;
 	int BlindEnable = 0;
+	int retry_get_link_status = 3;	// we only wait PHY 3 seconds to synchronzie with link partner.
+	int link_status =0;
 
 
 	NetSetHandler (NCSIHandler);
@@ -257,7 +259,7 @@
 			printf("NCSI:%d.%d Enable AEN Failed\n",PackageID, ChannelID);	
 			continue;
 		}
-
+#if 0 // we don't need to send link.
 		/* Enable Auto Negotiation */
 		if (NCSI_Issue_SetLink((UINT8)PackageID,(UINT8)ChannelID,1,0,0) != 0)
 		{
@@ -272,7 +274,7 @@
 			//Yiche20080219 udelay(1000*1000);
 			udelay(100);
 		}
-
+#endif
 
 		/* Set this channel info is setup */
 		ChannelInfo[i].Valid = 1;
@@ -304,37 +306,48 @@
 		}
 	}
 
-	/* Enable the Valid channels */
-	for(i=0;i<TotalChannels;i++)
-	{
-		if (ChannelInfo[i].Valid == 0)
-			continue;
-
-		PackageID = ChannelInfo[i].PackageID;
-		ChannelID = ChannelInfo[i].ChannelID;
-
-		if (BlindEnable)
-		{
-			DefaultPort--;
-			if (DefaultPort != 0)
-				continue;
-			if (EnableChannel(PackageID,ChannelID) != 0)
+	do {
+			/* Enable the Valid channels */
+			for(i=0;i<TotalChannels;i++)
 			{
-				printf("ERROR: Unable to Enable Package:Channel (%d:%d)\n",
-															PackageID,ChannelID);
+				if (ChannelInfo[i].Valid == 0)
+					continue;
+		
+				PackageID = ChannelInfo[i].PackageID;
+				ChannelID = ChannelInfo[i].ChannelID;
+		
+				if (BlindEnable)
+				{
+					DefaultPort--;
+					if (DefaultPort != 0)
+						continue;
+					if (EnableChannel(PackageID,ChannelID) != 0)
+					{
+						printf("ERROR: Unable to Enable Package:Channel (%d:%d)\n",
+																	PackageID,ChannelID);
+						break;
+					}
+				}
+				else
+				{
+					link_status =  EnableChannelOnLink(PackageID,ChannelID);
+					if ( link_status != 0)
+						continue;
+				}
+		
+				/* Only one channel should be enable at a time */
+				printf("NC-SI Enabled for Package:Channel (%d:%d)\n",PackageID,ChannelID);
 				break;
 			}
-		}
-		else
-		{
-			if (EnableChannelOnLink(PackageID,ChannelID) != 0)
+
+			if ( link_status !=0 && retry_get_link_status != 0 ) {
+				udelay(1000*1000);	// we need to wait for PHY and link partner that they are synchronize comletely when ac on.
+				retry_get_link_status--;
 				continue;
-		}
+			} else 
+				break;
+	} while ( link_status != 0 );
 
-		/* Only one channel should be enable at a time */
-		printf("NC-SI Enabled for Package:Channel (%d:%d)\n",PackageID,ChannelID);
-		break;
-	}
 	EnableVerbose(saved_verbose);
 	return;
 }
